#if !defined(AFX_DEVICELISTCTRL_H__08420ED1_A9D1_4426_93A4_A7170AA58E84__INCLUDED_)
#define AFX_DEVICELISTCTRL_H__08420ED1_A9D1_4426_93A4_A7170AA58E84__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DeviceListCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDeviceListCtrl window
extern "C"
{
#include <cfgmgr32.h>
#include <newdev.h> // for the API UpdateDriverForPlugAndPlayDevices().
#include <setupapi.h> // for SetupDiXxx functions.
}

#include "InfFileHelper.h"
#include "DriverSetupHelper.h"

/*
ڵ⣺removeһ豸windowsҵ豸ʱEzDriverSetupҲҲ豸
Ҫûֹϵͳˢwindowsҵ豸EzDriverSetup
Ӧкˢ豸˺þöûҵ
sofeiceezDriverInstallerҲͬ⡣
by xwpcom 2005-05-07

ҵ!DDKToolsʱdevconС
//*/
class CDeviceListCtrl : public CListCtrl
{
class CItemData
{
	friend class CDeviceListCtrl;
	int		m_nDeviceIndex;
	ULONG	m_uStatus,m_uProblem;
	SP_DEVINFO_DATA m_sdd;
	CItemData()
	{
		m_nDeviceIndex = -1;
		m_uStatus = m_uProblem = 0;
		ZeroMemory(&m_sdd,sizeof(m_sdd));
		m_sdd.cbSize = sizeof(m_sdd);
	}


};
// Construction
public:
	CDeviceListCtrl();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDeviceListCtrl)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	void OnBtn(UINT nID);
	BOOL IsDeviceDisabled(int nIndex = -1);
	BOOL Find(UINT nIDArr[], UINT cbSize, UINT nFind);
	BOOL IsFunctionEnabled(UINT nID);
	BOOL OpenInfFile(CString szInfFile);
	BOOL DeleteAllItems();
	void Reset();
	virtual ~CDeviceListCtrl();
	LRESULT OnDeviceChanged(WPARAM wp, LPARAM lp);

	// Generated message map functions
protected:
	void Test();
	void Select(int nIndex);
	int GetFirstSel();
	void Init();
	//{{AFX_MSG(CDeviceListCtrl)
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	
	SP_CLASSIMAGELIST_DATA	m_sid;
	HDEVINFO m_hDevInfo;
	CString m_szInfFile;
	CString m_szCurHwID;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DEVICELISTCTRL_H__08420ED1_A9D1_4426_93A4_A7170AA58E84__INCLUDED_)
