// EzDriverSetupDlg.h : header file
//

#if !defined(AFX_EZDRIVERSETUPDLG_H__8DC5AF0D_A923_4A0F_A070_F1F8650CB2EE__INCLUDED_)
#define AFX_EZDRIVERSETUPDLG_H__8DC5AF0D_A923_4A0F_A070_F1F8650CB2EE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CEzDriverSetupDlg dialog


#include "DeviceListCtrl.h"
class CEzDriverSetupDlg : public CDialog
{
// Construction
public:
	BOOL IsFunctionEnabled(UINT nID);
	BOOL Find(UINT nIDArr[], UINT cbSize, UINT nFind);
	CEzDriverSetupDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CEzDriverSetupDlg)
	enum { IDD = IDD_EZDRIVERSETUP_DIALOG };
	CComboBox	m_comboInf;
	CDeviceListCtrl	m_lstDevice;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEzDriverSetupDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void SaveWindowPos(BOOL bSave);
	void AddToolTips(UINT nIDArr[], UINT nSize);
	void AddToolTip(UINT nIDCtrl, UINT nIDString);
	void SetBtnText(UINT nID,UINT nIDS);
	void OnBtn(UINT nID);
	void OnUpdateBtn(CCmdUI *pCmdUI);
	LRESULT OnKickIdle(WPARAM wp,LPARAM lp);
	LRESULT OnDeviceChanged(WPARAM wp,LPARAM lp);
	void UpdateControlPos();
	BOOL Init();
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CEzDriverSetupDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSelchangeComboInf();
	afx_msg void OnBtnOpen();
	afx_msg void OnBtnClose();
	afx_msg void OnDropFiles(HDROP hDropInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	CToolTipCtrl m_toolTip;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EZDRIVERSETUPDLG_H__8DC5AF0D_A923_4A0F_A070_F1F8650CB2EE__INCLUDED_)
