// DriverSetupHelper.h: interface for the CDriverSetupHelper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRIVERSETUPHELPER_H__000DFA27_6297_48F5_A969_CCB1857E62F1__INCLUDED_)
#define AFX_DRIVERSETUPHELPER_H__000DFA27_6297_48F5_A969_CCB1857E62F1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

extern "C"
{
#include <cfgmgr32.h>
#include <newdev.h> // for the API UpdateDriverForPlugAndPlayDevices().
#include <setupapi.h> // for SetupDiXxx functions.
}

class CDriverSetupHelper  
{
public:
	static BOOL FindExistingDevice(CString szHardwareId);
	static BOOL Install(IN CString szInfFile,IN CString szHardwareID,IN BOOL bMultiInstance = TRUE OPTIONAL,OUT PBOOL pbRebootRequired = NULL OPTIONAL);
	CDriverSetupHelper();
	virtual ~CDriverSetupHelper();

protected:
	static BOOL InstallRootEnumeratedDriver(CString szInfFile,CString szHardwareID, OUT PBOOL pbRebootRequired=NULL);
};

#endif // !defined(AFX_DRIVERSETUPHELPER_H__000DFA27_6297_48F5_A969_CCB1857E62F1__INCLUDED_)
